<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

$ko_path = './';
include($ko_path.'inc/ko.inc');

switch($_GET["action"]) {
	case "file":
		//Nur Dateien aus dem Download-Verzeichnis des Webverzeichnises erlauben
		$full_path = realpath($_GET["file"]);
		//Find empty file
		if($full_path == '') ko_die('No file found');
		//Replace \ with / for windows systems otherwise the check below will always trigger an error
		if(DIRECTORY_SEPARATOR == '\\') $full_path = str_replace('\\', '/', $full_path);
		if(substr($full_path, 0, strlen($BASE_PATH."download")) != ($BASE_PATH."download")) {
			trigger_error('Not allowed download file: '.$_GET['file'], E_USER_ERROR);
			exit;
		}
		if(!file_exists($_GET["file"])) {
			exit;
		}
		if(substr($_GET["file"], 0, 1) == "/") {
			exit;
		}

		$dateiname = basename($_GET["file"]);
	break;  //case "file"


	case "passthrough":
		ko_returnfile($_GET["file"]);
		exit;
	break;


	case 'email':
		$only_send = TRUE;
	break;

	
	default:
		exit;
}//switch(action)
?>
<!DOCTYPE html 
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title><?php print getLL("download_title")." ".$dateiname; ?></title>
<?php
print ko_include_css();
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/kOOL.js\'></script>';
?>
</head>

<body>
<?php
if(!$only_send) {
	print '<br /><table width="100%" cellspacing="0"><tr><td class="subpart_header">'.getLL("download_file_header").'</td><td>&nbsp;</td></tr>';
	print '<tr><td class="subpart" colspan="2">'.getLL("download_file").'<br /><br />';
	print '<b>' . getLL('download_file_file') . '</b> <a href="'.$BASE_URL.$_GET["file"].'" target="_blank">'.ko_html($dateiname).'</a>';
	print '</td></tr></table>';

	print '<br /><p align="center"><a href="javascript:TINY.box.hide()">'.getLL("download_close_window").'</a></p>';
}



if(isset($_GET['send'])) {
	if(!$only_send) {
		print '<p><a href="javascript:TINY.box.size(720,560);change_vis(\'download_send\');"><b>&raquo;&nbsp;'.getLL('download_send').'</b></a></p>';
	}

	print '<div id="download_send" '.($only_send ? '' : 'style="display: none; visibility: hidden;"').'>';
		print '<form action="index.php?action=filesend" method="POST">';
		print '<input type="hidden" name="only_send" value="'.($only_send ? 1 : 0).'" />';
		print '<input type="hidden" name="filename" value="'.$_GET['file'].'" />';
		print '<input type="hidden" name="filetype" value="'.$_GET['filetype'].'" />';

		print '<b>'.getLL('download_send_sender').':</b><br />';
		print '<select name="sender" size="0" style="width: 700px; margin-bottom: 10px;">';
		//Sender: one of the email addresses of this login
		$p = ko_get_logged_in_person();
		if(ko_get_leute_email($p, $emails)) {
			foreach($emails as $email) {
				if(!$email) continue;
				$name = $p['vorname'] || $p['nachname'] ? $p['vorname'].' '.$p['nachname'] : $p['firm'];
				print '<option value="'.$email.'">&quot;'.$name.'&quot; &lt;'.$email.'&gt;</option>';
			}
		} else {
			$info_email = ko_get_setting('info_email');
			print '<option value="'.$info_email.'">'.$info_email.'</option>';
		}
		print '</select><br />';


		//Possible recipient options
		print '<div style="float: left; width: 200px;"><b>'.getLL('download_send_recipients').':</b><br />';
		print '<select name="recipients" size="0" style="width: 200px; margin-bottom: 10px;" id="recipients">';

		switch($_GET['send']) {
			case 'rota':
				ko_get_access('rota');
				if($access['rota']['MAX'] < 4) continue;

				print '<option value="schedulled" title="'.getLL('rota_send_schedulled').'">'.getLL('rota_send_schedulled').'</option>';
				print '<option value="selectedmembers" title="'.getLL('rota_send_selectedmembers').'">'.getLL('rota_send_selectedmembers').'</option>';
				print '<option value="selectedleaders" title="'.getLL('rota_send_selectedleaders').'">'.getLL('rota_send_selectedleaders').'</option>';
				if($access['rota']['ALL'] > 3) {
					print '<option value="allrotamembers" title="'.getLL('rota_send_allrotamembers').'">'.getLL('rota_send_allrotamembers').'</option>';
					print '<option value="allrotaleaders" title="'.getLL('rota_send_allrotaleaders').'">'.getLL('rota_send_allrotaleaders').'</option>';
				}
				print '<option value="manualmembers" title="'.getLL('rota_send_manualmembers').'">'.getLL('rota_send_manualmembers').'</option>';
				print '<option value="manualleaders" title="'.getLL('rota_send_manualleaders').'">'.getLL('rota_send_manualleaders').'</option>';
				print '<option value="single" title="'.getLL('rota_send_single').'">'.getLL('rota_send_single').'</option>';

				//Set default subject
				include_once($ko_path.'rota/inc/rota.inc');
				if(substr($_GET['filetype'], 0, 5) == 'event') {
					list($mode, $eventid) = explode(':', $_GET['filetype']);
					$event = db_select_data('ko_event AS e, ko_eventgruppen AS eg', "WHERE e.id = '$eventid' AND eg.id = e.eventgruppen_id", 'e.*, eg.name AS eventgruppen_name', '', '', TRUE);
					$subject = getLL('download_send_subject_default').' '.$event['eventgruppen_name'].' '.strftime($DATETIME['dMY'], strtotime($event['startdatum']));
				} else {
					$subject = getLL('download_send_subject_default').' '.ko_rota_timespan_title($_SESSION['rota_timestart'], $_SESSION['rota_timespan']);
				}


				//Add select for recipient mode single
				$options['single']  = '<b>'.getLL('rota_send_single_title').':</b><br />';
				$options['single'] .= '<select name="single_id[]" size="12" style="width: 200px;" multiple="multiple">';
				//Get all rota team members
				$teams = db_select_data('ko_rota_teams', 'WHERE 1', '*', 'ORDER BY name ASC');
				$people = array();
				foreach($teams as $tid => $team) {
					if($access['rota']['ALL'] < 4 && $access['rota'][$tid] < 4) continue;
					$rec = ko_rota_get_team_members($tid, TRUE);
					$people = array_merge($people, (array)$rec['people']);
				}
				//Sort all possible recipients
				$sort_keys = array();
				foreach($people as $p) {
					$sorted_people[$p['id']] = $p['vorname'].' '.$p['nachname'];
					if(ko_get_userpref($_SESSION['ses_userid'], 'rota_orderby') == 'vorname') $sort_keys[$p['id']] = $p['vorname'].$p['nachname'];
					if(ko_get_userpref($_SESSION['ses_userid'], 'rota_orderby') == 'nachname') $sort_keys[$p['id']] = $p['nachname'].$p['vorname'];
				}
				asort($sort_keys);
				foreach($sort_keys as $id => $v) {
					$p = $sorted_people[$id];
					$options['single'] .= '<option value="'.$id.'">'.$p.'</option>';
				}
				$options['single'] .= '</select>';


				//Add a list of all teams to select from (for members)
				$options['manualmembers']  = '<b>'.getLL('rota_send_manualmembers_title').':</b><br />';
				$options['manualmembers'] .= '<select name="sel_teams_members[]" size="12" multiple="multiple" style="width: 200px; height: 170px;">';
				//Get all rota teams
				foreach($teams as $team) {
					if($access['rota']['ALL'] < 4 && $access['rota'][$team['id']] < 4) continue;
					$options['manualmembers'] .= '<option value="'.$team['id'].'">'.$team['name'].'</option>';
				}
				$options['manualmembers'] .= '</select>';


				//Add a list of all teams to select from (for leaders)
				$options['manualleaders']  = '<b>'.getLL('rota_send_manualleaders_title').':</b><br />';
				$options['manualleaders'] .= '<select name="sel_teams_leaders[]" size="12" multiple="multiple" style="width: 200px; height: 170px;">';
				//Get all rota teams
				foreach($teams as $team) {
					if($access['rota']['ALL'] < 4 && $access['rota'][$team['id']] < 4) continue;
					$options['manualleaders'] .= '<option value="'.$team['id'].'">'.$team['name'].'</option>';
				}
				$options['manualleaders'] .= '</select>';

			break;

		}//switch(_GET[send])

		print '</select>';

		if(is_array($options)) {
			foreach($options as $key => $code) {
				print '<div class="recipients_options" style="display: none;" id="options_'.$key.'">'.$code.'</div>';
			}
		}
		
		print '</div>';

		
		print '<div style="float: left; width: 485px; margin-left: 15px;">';
		print '<b>'.getLL('download_send_subject').':</b><br />';
		print '<input type="text" name="subject" style="width: 485px; margin-bottom: 10px;" value="[kOOL] '.$subject.'"><br />';
		print '<b>'.getLL('download_send_text').':</b><br />';

		if($_GET['send'] == 'rota') {
			//Show select with placeholders for rota
			print '<select name="placeholder" size="0" id="placeholder" style="width: 485px;" onchange="textarea_insert_text(\'emailtext\', \'[[\'+this.value+\']]\');">';
			print '<option value="">'.getLL('download_send_insert_placeholder').'</option>';
			print '<option value="" disabled="disabled">-------------------------</option>';
			foreach(array('_SALUTATION', '_SALUTATION_FORMAL', 'FIRSTNAME', 'LASTNAME', 'TEAM_NAME', 'PERSONAL_SCHEDULE', 'TEAM_EVENTS', 'TEAM_EVENTS_SCHEDULE', 'ALL_EVENTS', 'ALL_EVENTS_SCHEDULE') as $key) {
				//print '<option value="'.$key.'">[['.$key.']]: '.getLL('rota_placeholder_'.$key).'</option>';
				print '<option value="'.$key.'">[['.$key.']]</option>';
				print '<option disabled="disabled">'.getLL('rota_placeholder_'.$key).'</option>';
			}
			print '</select>';

			//Show select for presets for the mail text
			print '<div name="text_presets" id="text_presets">';
			print '<select name="preset" size="0" id="preset" style="width: 465px; float: left;" onchange="textarea_insert_text(\'emailtext\', this.value);">';
			print '<option value="">'.getLL('download_send_insert_preset').'</option>';
			print '<option value="" disabled="disabled">-------------------------</option>';
			$presets = array_merge((array)ko_get_userpref('-1', '', 'rota_emailtext_presets', 'ORDER by `key` ASC'), (array)ko_get_userpref($_SESSION['ses_userid'], '', 'rota_emailtext_presets', 'ORDER by `key` ASC'));
			foreach($presets as $preset) {
				$prefix = $preset['user_id'] == -1 ? getLL('itemlist_global_short').' ' : '';
				print '<option id="preset_'.$preset['id'].'" value="'.ko_js_escape($preset['value']).'">'.$prefix.$preset['key'].'</option>';
			}
			print '</select></div>';
			//Icon to delete presets
			print '<input type="image" name="del_preset" src="../images/icon_trash.png" alt="X" onclick="sendReq(\'../rota/inc/ajax.php\', \'action,id,sesid\', \'delpreset,\'+document.getElementById(\'preset\').options[document.getElementById(\'preset\').selectedIndex].id+\','.session_id().'\', do_element); return false;" />';
		}
		print '<textarea name="text" id="emailtext" cols="40" rows="10" style="width: 485px; height: 170px;"></textarea>';

		//Save as new text template
		print '<div style="width: 485px; white-space: nowrap; text-align: right;">';
		print '<span style="display: inline;">'.getLL('download_send_new_preset').':</span>&nbsp;<input type="text" name="save_preset" style="display: inline;" />';
		if($access['rota']['MAX'] > 4) print '&nbsp;<input type="checkbox" name="chk_global" id="preset_global" value="1" style="display: inline;" /><label for="preset_global" style="display: inline;">'.getLL('itemlist_global').'</label>';
		print '</div>';

		print '<p align="center"><input type="submit" name="submit_send" value="'.getLL('download_send_send').'" onclick="TINY.box.hide();" /></p>';
		print '</div>';


	print '</form></div>';
}
?>
</body>
</html>
