<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Session-ID verlangen
if(!isset($_GET["sesid"])) exit;

//Session laden
if(FALSE === session_id($_GET["sesid"])) exit;
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');

error_reporting(0);
$ko_menu_akt = 'home';
$ko_path = "../";
require($ko_path."inc/ko.inc");

//Smarty-Templates-Engine laden
require($BASE_PATH."inc/smarty.inc");

//Include plugin code
$hooks = hook_include_main('_all');
if(sizeof($hooks) > 0) foreach($hooks as $hook) include_once($hook);

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

hook_show_case_pre($_SESSION['show']);


if(isset($_GET) && isset($_GET["action"])) {
	$action = format_userinput($_GET["action"], "alphanum");
	switch($action) {
		case "opensm":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			//Bestehende SM dieses Benutzers holen
			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));
			if(in_array($id, $open)) continue;

			//Geschlossenes ffnen
			$new_open = implode(",", $open);
			$new_closed = "";
			foreach($closed as $c) {
				if($c == $id) {
					$new_open .= ($new_open == "") ? $c : ",$c";
				} else {
					$new_closed .= $c.",";
				}
			}
			//Werte neu speichern
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed", substr($new_closed, 0, -1));
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos, $new_open);

			//Neuen HTML-Code fr SM ausgeben
			eval("\$r=submenu_".$sm_module.'($id, $pos, "open", 2);');
			print $r;
		break;


		case "closesm":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			//Bestehende SM dieses Benutzers holen
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));
			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			if(in_array($id, $closed)) continue;

			//Offenes schliessen
			$new_closed = implode(",", $closed);
			$new_open = "";
			foreach($open as $c) {
				if($c == $id) {
					$new_closed .= ($new_closed == "") ? $c : ",$c";
				} else {
					$new_open .= $c.",";
				}
			}
			//Werte neu speichern
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed", $new_closed);
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos, substr($new_open, 0, -1));

			//Neuen HTML-Code fr SM ausgeben
			eval("\$r=submenu_".$sm_module.'($id, $pos, "closed", 2);');
			print $r;
		break;



		case "movesmup":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));

			//Zustand finden
			if(in_array($id, $closed)) {  //Falls geschlossen
				$state = "_closed";
				$array = $closed;
			}
			if(in_array($id, $open)) {  //Falls offen
				$state = "";
				$array = $open;
			}

			//Index finden des zu verschiebenden Submenus
			for($i = 0; $i<sizeof($array); $i++) {
				if($array[$i] == $id) $index = $i;
			}
			//if($index == 0) continue;

			//Submenu tauschen (resp. nach oben schieben)
			$temp = $array[($index-1)];
			$array[($index-1)] = $array[$index];
			$array[$index] = $temp;

			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos.$state, implode(",", $array));
			$_SESSION["submenu_".$pos.$state] = implode(",", $array);

			//Neuen HTML-Code fr SM ausgeben
			print "main_".$pos."@@@";
			print ko_get_submenu_code($sm_module, $pos);
		break;


		case "movesmdown":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));

			//Zustand finden
			if(in_array($id, $closed)) {  //Falls geschlossen
				$state = "_closed";
				$array = $closed;
			}
			if(in_array($id, $open)) {  //Falls offen
				$state = "";
				$array = $open;
			}

			//Index finden des zu verschiebenden Submenus
			for($i = 0; $i<sizeof($array); $i++) {
				if($array[$i] == $id) $index = $i;
			}
			if($index == (sizeof($array)-1)) continue;

			//Submenu tauschen (resp. nach oben schieben)
			$temp = $array[($index+1)];
			$array[($index+1)] = $array[$index];
			$array[$index] = $temp;

			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos.$state, implode(",", $array));
			$_SESSION["submenu_".$pos.$state] = implode(",", $array);

			//Neuen HTML-Code fr SM ausgeben
			print "main_".$pos."@@@";
			print ko_get_submenu_code($sm_module, $pos);
		break;


		case "savenote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

			if($_GET["notename"] == "" && $_GET["selnote"]) {  //Falls keine Name angegeben, dann die aktuelle Notiz berschreiben...
	      $save_key = format_userinput($_GET["selnote"], "alphanum++");
	    } else if($_GET["notename"]) {  //... sonst als neue Notiz speichern
	      $save_key = format_userinput($_GET["notename"], "alphanum++");
	    } else {
	      continue;
	    }
						    
	    ko_save_userpref($_SESSION["ses_userid"], $save_key, format_userinput($_GET["note"], "text"), "notizen");
	    $_SESSION["show_notiz"] = $save_key;

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "opennote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

      $save_key = format_userinput($_GET["selnote"], "alphanum++");
			if(!$save_key) continue;

			$_SESSION["show_notiz"] = $save_key;

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "deletenote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

      $del_key = format_userinput($_GET["selnote"], "alphanum++");
			if(!$del_key) continue;

			ko_delete_userpref($_SESSION["ses_userid"], $del_key, "notizen");
	    $_SESSION["show_notiz"] = "";

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "exporttomylist":
			$ids = format_userinput(str_replace('@', ',', $_GET['ids']), 'intlist');
			$_SESSION['my_list'] = array();
			foreach(explode(',', $ids) as $id) {
				if($id) $_SESSION['my_list'][$id] = $id;
			}
			ko_save_userpref($_SESSION['ses_userid'], 'leute_my_list', serialize($_SESSION['my_list']));

			print 'mailmerge_infobox@@@';
			print getLL('leute_mailmerge_mylist_export_ok');
		break;


		case 'inlineform':
			$module = format_userinput($_GET['module'], 'alphanum+');

			list($table, $id, $col) = explode('|', $_GET['id']);
			$table = format_userinput($table, 'alphanum+');
			$id = format_userinput($id, 'uint');
			$col = format_userinput(str_replace(':', ',', $col), 'alphanumlist');
			$cols = explode(',', $col);

			if($table == '' || $id <= 0 || $col == '') continue;

			//Get access and KOTA for this module
			ko_get_access($module);
			ko_include_kota(array($table));


			//Don't show inline form if setting in KOTA is set accordingly
			foreach($cols as $ci => $column) {
				if($KOTA[$table][$column]['form']['noinline'] === TRUE) unset($cols[$ci]);
			}
			if(sizeof($cols) == 0) continue;

			//Access check
			if(!$KOTA[$table]['_access']['level'] || !isset($KOTA[$table]['_access']['chk_col'])) continue;

			$entry = db_select_data($table, "WHERE `id` = '$id'", '*', '', '', TRUE);
			$chk_col = $KOTA[$table]['_access']['chk_col'];
			$rights_level = $KOTA[$table]['_access']['level'];
			$ok = FALSE;
			if(substr($chk_col, 0, 4) == 'ALL&') {
				$ok = ($access[$module]['ALL'] >= $rights_level || $access[$module][$entry[substr($chk_col, 4)]] >= $rights_level);
			} else if($chk_col != '') {
				$ok = ($access[$module][$entry[$chk_col]] >= $rights_level);
			} else {
				$ok = ($access[$module]['ALL'] >= $rights_level);
			}

			//Check for column access for leute module
			if($table == 'ko_leute') {
				//get the cols, for which this user has edit-rights (saved in allowed_cols[edit])
				$allowed_cols = ko_get_leute_admin_spalten($_SESSION['ses_userid'], 'all');

				//Check for edit access
				if(is_array($allowed_cols) && sizeof($allowed_cols) > 0) {
					foreach($cols as $ci => $column) {
						//Ignore MODULE column like groups and datafields.
						if(substr($column, 0, 6) == 'MODULE') continue;
						if(is_array($allowed_cols['edit']) && !in_array($column, $allowed_cols['edit'])) unset($cols[$ci]);
					}
					if(sizeof($cols) == 0) $ok = FALSE;
				}
			}

			//Type check: Check for this rows type and if this column may be edited
			if(isset($KOTA[$table]['_types']['field']) && $entry[$KOTA[$table]['_types']['field']] != $KOTA[$table]['_types']['default']) {
				$kota_type = $entry[$KOTA[$table]['_types']['field']];
				foreach($cols as $column) {
					if(!in_array($column, $KOTA[$table]['_types']['types'][$kota_type]['use_fields'])
					&& !in_array($column, array_keys($KOTA[$table]['_types']['types'][$kota_type]['add_fields']))) {
						$ok = FALSE;
					}
				}
			}

			//Check for access condition
			if(isset($KOTA[$table]['_access']['condition'])) {
				if(FALSE === eval(strtr($KOTA[$table]['_access']['condition'], $entry))) $ok = FALSE;
			}

			if(!$ok) continue;


			if($table == 'ko_leute' && substr($col, 0, 9) == 'MODULEgdf') {
				$dfid = substr($col, 16, 6);
				$df = db_select_data('ko_groups_datafields', "WHERE `id` = '$dfid'", '*', '', '', TRUE);
			}

			//Treat checkbox directly by changing it's value (allow only one checkbox to be treated directy, so check for $col not $cols)
			if(in_array($KOTA[$table][$col]['form']['type'], array('checkbox', 'switch'))) {
				//Update value in db
				$data = db_select_data($table, "WHERE `id` = '$id'", '*', '', '', TRUE);
				$data[$col] = $data[$col] == 0 ? 1 : 0;
				db_update_data($table, "WHERE `id` = '$id'", array($col => $data[$col]));

				//Save changes for ko_leute
				if($table == 'ko_leute') ko_save_leute_changes($id, $data);

				//Output new value
				kota_process_data($table, $data, 'list', $log, $id);
				print $_GET['id'].'@@@'.$data[$col];
			}
			//Check for GDF checkbox
			else if($table == 'ko_leute' && substr($col, 0, 9) == 'MODULEgdf' && $df['type'] == 'checkbox') {
				//Find current entry for GDF
				$dfid = substr($col, 15, 6);
				$gid = substr($col, 9, 6);
				if($access['groups']['ALL'] < 2 && $access['groups'][$gid] < 2) continue;
				$dfdata = db_select_data('ko_groups_datafields_data', "WHERE `datafield_id` = '$dfid' AND `person_id` = '$id' AND `group_id` = '$gid' AND `deleted` = '0'");

				//Check if this person is assigned to the given group
				$person = db_select_data($table, "WHERE `id` = '$id'", '*', '', '', TRUE);
				if(FALSE === strpos($person['groups'], 'g'.$gid)) continue;

				//Save changes for ko_leute
				ko_save_leute_changes($id, $person);

				//Update or insert value
				if(sizeof($dfdata) > 0) {
					$dfdata = array_shift($dfdata);
					$value = $dfdata['value'] == 0 ? 1 : 0;
					db_update_data('ko_groups_datafields_data', "WHERE `id` = '".$dfdata['id']."'", array('value' => $value));
				} else {
					$value = 1;
					db_insert_data('ko_groups_datafields_data', array('group_id' => $gid, 'datafield_id' => $dfid, 'person_id' => $id, 'value' => $value));
				}

				//Output new value
				print $_GET['id'].'@@@'.($value ? getLL('yes') : getLL('no'));
			}
			//For all other input types show form
			else {
				$grp = ko_multiedit_formular($table, explode(',', $col), $id, '', '', TRUE);

				$inputs = FALSE;
				foreach($grp as $i) {
					if($i['forAll'] == 1) continue;
					foreach($i['row'] as $row) {  //Get inputs from all rows
						foreach($row['inputs'] as $in) {
							$inputs[] = $in;
						}
					}
				}

				if(is_array($inputs)) {
					$classes = array('inlineform');
					$code = '';
					foreach($inputs as $input) {
						$smarty->assign('input', $input);
						$code .= $smarty->fetch('ko_formular_elements.tmpl');
					}

					//Add submit button for input types doubleselect
					if(in_array($KOTA[$table][$col]['form']['type'], array('doubleselect'))
						|| ($table == 'ko_leute' && substr($col, 0, 9) == 'MODULEgdf' && $df['type'] == 'multiselect')) {
						$classes[] = 'if-doubleselect';
						$code .= '<div><input type="button" name="if_submit" class="if_submit" value="'.getLL('OK').'" /></div>';
					}

					if($code) print $_GET['id'].'@@@<div class="'.implode(' ', $classes).'" id="if_'.$_GET['id'].'">'.$code.'</div>';
				}
			}
		break;


		case 'inlineformblur':
			$module = format_userinput($_GET['module'], 'alphanum+');

			list($table, $id, $col) = explode('|', $_GET['id']);
			$table = format_userinput($table, 'alphanum+');
			$id = format_userinput($id, 'uint');
			$col = format_userinput(str_replace(':', ',', $col), 'alphanumlist');
			$col = array_shift(explode(',', $col));

			if(!$table || !$col || !$id) continue;

			ko_get_access($module);
			ko_include_kota(array($table));

			$data = db_select_data($table, "WHERE `id` = '$id'", '*', '', '', TRUE);
			//Add column if a special column has been shown
			if(substr($col, 0, 6) == 'MODULE') $data[$col] = '';
			$kota_data = $data;
			kota_process_data($table, $kota_data, 'list', $log, $id);

			print $_GET['id'].'@@@'.$kota_data[$col];
		break;


		case 'inlineformsubmit':
			$module = format_userinput($_GET['module'], 'alphanum+');

			list($table, $id, $col) = explode('|', $_GET['id']);
			$table = format_userinput($table, 'alphanum+');
			$id = format_userinput($id, 'uint');
			$orig_col = $col = format_userinput(str_replace(':', ',', $col), 'alphanumlist');
			//Sort columns (important for check in kota_submit_multiedit)
			$a = explode(',', $col); sort($a); $col = implode(',', $a);

			ko_get_access($module);
			ko_include_kota(array($table));

			//Replace masked commas
			foreach($a as $c) {
				$_GET['koi'][$table][$c][$id] = str_replace('|', ',', $_GET['koi'][$table][$c][$id]);
				$_GET['koi'][$table][$c][$id] = str_replace('<br />', "\n", $_GET['koi'][$table][$c][$id]);
			}

			$_POST['koi'] = $_GET['koi'];
			$hash = md5(md5($mysql_pass.$table.str_replace(',', ':', $col).$id));
			$_POST['id'] = $table.'@'.$col.'@'.$id.'@'.$hash;
			kota_submit_multiedit($error);

			if($error) {
				print 'ERROR@@@'.getLL('error_'.$table.'_'.$error);
				continue;
			}

			//Check redraw conditions
			$redraw = FALSE;
			foreach($KOTA[$table]['_inlineform']['redraw'] as $method => $value) {
				switch($method) {
					case 'sort':
						foreach(explode(',', $orig_col) as $c) {
							if(isset($_SESSION[$value]) && (is_array($_SESSION[$value]) && in_array($c, $_SESSION[$value])) || (!is_array($_SESSION[$value]) && $c == $_SESSION[$value]) ) $redraw = TRUE;
						}
					break;
					case 'cols':
						if(!is_array($value)) $value = explode(',', $value);
						foreach(explode(',', $orig_col) as $c) {
							if(in_array($c, $value)) $redraw = TRUE;
						}
					break;
				}
			}

			//Redraw whole list if need be
			if($redraw) {
				print 'main_content@@@';
				list($module, $file) = explode('|', $KOTA[$table]['_inlineform']['module']);
				$file = $file != '' ? $file : $module;
				include_once($ko_path.$module.'/inc/'.$file.'.inc');
				eval($KOTA[$table]['_inlineform']['redraw']['fcn']);
			}
			//Just redraw single table cell
			else {
				//Get record from DB
				$data = db_select_data($table, "WHERE `id` = '$id'", '*', '', '', TRUE);
				//Add column if a special column has been edited
				if(substr($col, 0, 6) == 'MODULE') $data[$col] = $_POST['koi'][$table][$col][$id];
				kota_process_data($table, $data, 'list', $log, $id);

				//Get first column (if multiple) to return it's value
				$col = array_shift(explode(',', $orig_col));
				print $_GET['id'].'@@@'.$data[$col];
			}
		break;
	}//switch(action);
}//if(GET[action])
?>
